# License:
#   Copyright (C) 2011 Thomas GUILLET, Damien CHAPON, Marc LABADENS. All Rights Reserved.
#
#   This file is part of PyMSES.
#
#   PyMSES is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   PyMSES is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with PyMSES.  If not, see <http://www.gnu.org/licenses/>.
from pymses.utils.regions import Box
from pymses.filters import RegionFilter

def amr2cube(source, var, xmin, xmax, cubelevel):
	r"""
	amr2cube tool.

	"""
	out = None

	# Region CPU-filtering
	b = Box([xmin, xmax])
	rsource = RegionFilter(b, source)

	for dset in rsource.iter_dsets():
		if out is None:
			out = dset.to_cartesian(var, xmin, xmax, cubelevel)
		else:
			dset.to_cartesian(var, xmin, xmax, cubelevel, dest=out)

	return out

__all__ = ["amr2cube"]
